#!/usr/bin/env node
/* jshint node:true */
/*global setImmediate*/
//Marketinator
var express = require("express"),
    path = require('path'),
    http = require('http'),
	mysql = require('mysql'),
	fs=require('fs');
    
var app = express(),
    server = http.createServer(app);
	
var prevIds=[];
var prevIdcpt=0;

var prevAttr=[];
var prevAttrcpt=0;

var answers=[];
var possArrStr="";
var possibleAnswers=[];
	
var connection = mysql.createConnection({
  host : '192.168.128.92',
  port : 3306,
  database: 'marketinator',
  user : 'Arthur',
  password : 'arthur'
});

app.configure(function() {
	app.use('/files', express.static(path.join(__dirname, 'files')));
	app.use(express.logger('dev'));
	app.use(express.bodyParser());
	//app.use(express.multipart());

	app.get('/', index);
	
	app.post('/forms/answer', formAnswer);
	app.post('/forms/new', formNew);
	app.post('/forms/newProd', formNewProd);

	app.use(function errorHandler(err, req, res, next){
		console.error(err.stack);
		res.status(500).send(err.toString());
	});
});

server.listen(9999, null, null, function () {
	var tcpAddr = server.address(),
	    url = "http://192.168.128.98:" + tcpAddr.port;
	console.log("Now running at <" + url + ">");
});

function index(req, res, next) {
	res.writeHeader(200);
	

	connection.query("SELECT * from marketinator.questions", function(err, rows){

        if(err != null) {
            res.end("Query error:" + err);
        } else {

			var nbQuest = rows.length;
			console.log("nbQuest "+nbQuest);
			var rdmQuest = 0;
			do{
				rdmQuest = Math.floor(Math.random()*(nbQuest+1));
				console.log("random"+rdmQuest);
			}while(rdmQuest == nbQuest);
			
			var htmlAns = getAnswers(rows[rdmQuest].reponses);
			
			
			
			var ansId=rows[rdmQuest].id;
			var attr=rows[rdmQuest].attribut;
			
			prevIds=[];
			prevIdcpt=0;
			prevAttr=[];
			prevAttrcpt=0;
			answers=[];
			possArrStr="";
			possibleAnswers=[];
			
			var html = 
		    "<!DOCTYPE html>" +
		    "<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">" +
		    "<title>Marketinator</title>" +
		    "</head><body><script>var fin=false;var intitule='"+
			rows[rdmQuest].intitule+"';var answer='"+
			htmlAns+
			"';var ansId="+
			ansId	
			+";var attr='"+
			attr
			+"';var newProd=false;</script></body>"+
			"<script src=\"/files/script.js\"></script></html>";
            res.end(html);
        }
	 });
}

 function getAnswers(string){
	var answers = string.split(';');
	var html = "";
	for (var ans in answers)
		html += "<br>" + answers[ans];
	return html;
 }


function formAnswer(req, res, next) {
	var ansId = parseInt(req.param('ansId'), 10);
	prevIds[prevIdcpt++]=ansId;
	var answer = req.param('answer');
	answers[prevAttrcpt]=answer;
	var attr=req.param('attr');
	prevAttr[prevAttrcpt++]=attr;
	var filter="";
	for(var i=0;i<prevIdcpt;i++) filter+=" questions.id <> "+prevIds[i]+" AND";
	filter=filter.substring(0,filter.length-4);
	console.log(filter);
	
	var attrFilter="";
	for(var i=0;i<prevAttrcpt;i++) attrFilter+=" produits."+prevAttr[i]+" = '"+answers[i]+"' AND";
	attrFilter=attrFilter.substring(0,attrFilter.length-4);
	
	connection.query("SELECT * from marketinator.produits WHERE"+attrFilter, function(err, rows){
		var prodRows=rows;
		console.log("SELECT * from marketinator.produits WHERE"+attrFilter);

        if(err != null) {
            res.end("Query error:" + err);
        } else {
			var nbProd = rows.length;
			console.log("nbProd "+nbProd);
			if(nbProd>1){
				connection.query("SELECT * from marketinator.questions WHERE"+filter, function(err, rows){
					console.log("SELECT * from marketinator.questions WHERE"+filter);

					if(err != null) {
						res.end("Query error:" + err);
					} else if (rows.length>0){

						var nbQuest = rows.length;
						console.log("nbQuest "+nbQuest);
						var rdmQuest = 0;
						if(nbQuest > 0){
							do{
								rdmQuest = Math.floor(Math.random()*(nbQuest+1));
								console.log("random"+rdmQuest);
							}while(rdmQuest == nbQuest);
						}

						var htmlAns = getAnswers(rows[rdmQuest].reponses);
						var ansId=rows[rdmQuest].id;
						var attr=rows[rdmQuest].attribut;
						
						var html = 
									"<!DOCTYPE html>" +
									"<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">" +
									"<title>Marketinator</title>" +
									"</head><body><script>var fin=false;var intitule='"+
									rows[rdmQuest].intitule+"';var answer='"+
									htmlAns+
									"';var ansId="+
									ansId	
									+";var attr='"+
									attr
									+"';var newProd=false;</script></body>"+
									"<script src=\"/files/script.js\"></script></html>";
						res.status(200).send(html);
					}else{
						var html = 
						"<!DOCTYPE html>" +
						"<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">" +
						"<title>Marketinator</title>" +
						"</head><body><script>var fin=true;var imageURL='"+
						prodRows[0].image+"';var nom='"+
						prodRows[0].nom+"';var newProd=false;</script></body>"+
						"<script src=\"/files/script.js\"></script></html>";
						res.status(200).send(html);
					}
				});
			}else if(nbProd==1){
				var html = 
						"<!DOCTYPE html>" +
						"<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">" +
						"<title>Marketinator</title>" +
						"</head><body><script>var fin=true;var price="+prodRows[0].prix+";var stock="+prodRows[0].stock+";var imageURL='"+
						rows[0].image+"';var nom='"+
						rows[0].nom+"';var newProd=false;</script></body>"+
						"<script src=\"/files/script.js\"></script></html>";
						res.status(200).send(html);
			}else{
				
				var html = 
						"<!DOCTYPE html>" +
						"<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">" +
						"<title>Marketinator</title>" +
						"</head><body><script>var newProd=false;var fin=true;var imageURL='rien';var price=0;var nom='RIEN';</script></body>"+
						"<script src=\"/files/script.js\"></script></html>";
						res.status(200).send(html);
			}
		}
	});
}

function formNew(req, res, next) {
	connection.query("SELECT * from marketinator.questions", function(err, rows){
	if(err != null) {
            res.end("Query error:" + err);
        } else {
			
			possArrStr+="[";
			for(var i in rows){
				possibleAnswers[i]=[];
				possArrStr+="['";
				for(var j in rows[i].reponses.split(';')){
					possibleAnswers[i][j]=(j==0)?rows[i].attribut:rows[i].reponses.split(';')[j-1];
					possArrStr+=possibleAnswers[i][j]+"','";
				}
				possibleAnswers[i][j]=rows[i].reponses.split(';')[j];
				possArrStr+=possibleAnswers[i][j]+"','";
				possArrStr=possArrStr.substring(0,possArrStr.length-3);
				possArrStr+="'],";
			}
			possArrStr=possArrStr.substring(0,possArrStr.length-1);
			possArrStr+="]";
			//console.log("possArrStr="+possArrStr);
		
			console.log("possArrStr="+possArrStr);
			var html = 
					"<!DOCTYPE html>" +
					"<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">" + 
					"<title>Marketinator</title>" +
					"</head><body><script>"+
					"var possArr="+possArrStr
					+";var newProd=true;var fin=false;</script></body><script src=\"/files/script.js\"></script></html>";
			res.status(200).send(html);
		}
		
	});
}

function formNewProd(req, res, next) {
	var selects=[];
	var options=[];
	for(var i in possibleAnswers){
		selects[i]=possibleAnswers[i][0];
		options[i]=req.param(possibleAnswers[i][0]);
	}
	var insert="",insert2="";
	for(var i in selects) insert+=selects[i]+",";
	insert+="prix,stock,nom,image";
	for(var i in options) insert2+="'"+options[i]+"',";
	insert2+="1,0,'"+req.param('name')+"','"+req.param('name')+"'";
	
	fs.readFile(req.files.image.path, function (err, data) {
		var newPath = __dirname+"/files/images/produits/"+req.param('name')+".png";
		fs.writeFile(newPath, data, function (err) {
			console.log(err);
		});
	});
	
	connection.query("INSERT INTO marketinator.produits ("+insert+") VALUES ("+insert2+")", function(err, rows){
	console.log("INSERT INTO marketinator.produits ("+insert+") VALUES ("+insert2+")");
		if(err != null) {
			res.end("Query error:" + err);
		}
	});	
	var html = 
		    "<!DOCTYPE html>" +
		    "<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">" + 
		    "<title>Marketinator</title>" +
		    "</head><body><script>location.href=\"/\";</script></html>";
	res.status(200).send(html);
}